#-
#:SmallSize 5000000
#:LargeSize 20000000
#:WorkSpace 50000000
#:MaxTermSize 300000
#:TermsInSmall 30000
off stats;
format 75;
auto s sM;
auto i iM;

s GS, MT, MT2;
cf Den, Denom, dirM, pol, polc, SUNF, SUND, SUNSum, SUNT;
cf SpinorU, SpinorUb, SpinorV, SpinorVb;
cf mom, fslash;

d 4;

AutoDeclare I Dir=4, iM, Lor=4,ind;

Tensor Tr(cyclic),Tp,f(antisymmetric),ff(rcyclic), d(symmetric);
Function TM,TT;
Symbols a,nf,NF,NA,cF,cA,[cF-cA/6];
Dimension NA;
AutoDeclare  I j,Glu=NA;
Dimension NF;
AutoDeclare I i,Col=NF;

v k;
s m;
f g,g1,g2,dummy;
v g6,g7;

v k1,k2,k3,k4;

#define DoColor "0"

#include squareME.h


.global
*********************************************************
*    _                    _ _ _             _           *
*   / \   _ __ ___  _ __ | (_) |_ _   _  __| | ___  ___ *
*  / _ \ | '_ ` _ \| '_ \| | | __| | | |/ _` |/ _ \/ __|*
* / ___ \| | | | | | |_) | | | |_| |_| | (_| |  __/\__ \*
*/_/   \_\_| |_| |_| .__/|_|_|\__|\__,_|\__,_|\___||___/*
*                  |_|                                  *
*********************************************************
Local Diag1 =
-1*polc(k1,Lor1)*polc(k2,Lor3)*dirM(SpinorUb(k3,MT),Dir2)*dirM(SpinorV(k4,MT),Dir4)*-GS*SUNF(Glu1,Glu3,Glu7)*(d_(Lor1,Lor3)*mom(k1-(k2),Lor7)+d_(Lor3,Lor7)*mom(k2-(-k1-k2),Lor1)+d_(Lor7,Lor1)*mom(-k1-k2-(k1),Lor3) )*i_*GS*dirM(g(iM,Lor8),Dir2,Dir4)*SUNT(Glu8,Col2,Col4)*-i_*Den(-k1-k2,0)*d_(Lor8,Lor7)*d_(Glu8,Glu7)*SUNSum(Glu7,8);
Local Diag2 =
+1*polc(k1,Lor1)*polc(k2,Lor3)*dirM(SpinorUb(k3,MT),Dir2)*dirM(SpinorV(k4,MT),Dir4)*i_*GS*dirM(g(iM,Lor1),Dir2,Dir7)*SUNT(Glu1,Col2,Col7)*i_*GS*dirM(g(iM,Lor3),Dir8,Dir4)*SUNT(Glu3,Col8,Col4)*i_*Den(-k1+k3,MT2)*d_(Col8,Col7)*SUNSum(Col7,3)*dirM(fslash(-k1+k3)+MT*g(iM),Dir7,Dir8);
Local Diag3 =
+1*polc(k1,Lor1)*polc(k2,Lor3)*dirM(SpinorUb(k3,MT),Dir2)*dirM(SpinorV(k4,MT),Dir4)*i_*GS*dirM(g(iM,Lor1),Dir8,Dir4)*SUNT(Glu1,Col8,Col4)*i_*GS*dirM(g(iM,Lor3),Dir2,Dir7)*SUNT(Glu3,Col2,Col7)*i_*Den(k1-k4,MT2)*d_(Col8,Col7)*SUNSum(Col7,3)*dirM(fslash(k1-k4)+MT*g(iM),Dir7,Dir8);

L Amp = +Diag1+Diag2+Diag3;

#$lomax = 8;
#$dimax = 8;
#call squareME(Amp,M1);
 .sort
Local Diag1 =
+1*1*1*dirM(SpinorUb(k3,MT),Dir2)*dirM(SpinorV(k4,MT),Dir4)*GS*SUNF(Glu7,Glu1,Glu3)*mom(k2,Lor7)*i_*GS*dirM(g(iM,Lor8),Dir2,Dir4)*SUNT(Glu8,Col2,Col4)*-i_*Den(-k1-k2,0)*d_(Lor8,Lor7)*d_(Glu8,Glu7)*SUNSum(Glu7,8);

L Amp = +Diag1;

#$lomax = 8;
#$dimax = 4;
#call squareME(Amp,M2);
 .sort
Local Diag1 =
-1*1*1*dirM(SpinorUb(k3,MT),Dir2)*dirM(SpinorV(k4,MT),Dir4)*GS*SUNF(Glu7,Glu3,Glu1)*mom(k1,Lor7)*i_*GS*dirM(g(iM,Lor8),Dir2,Dir4)*SUNT(Glu8,Col2,Col4)*-i_*Den(-k1-k2,0)*d_(Lor8,Lor7)*d_(Glu8,Glu7)*SUNSum(Glu7,8);

L Amp = +Diag1;

#$lomax = 8;
#$dimax = 4;
#call squareME(Amp,M3);
 .sort
L Result = M1-M2-M3;
.sort

Format nospaces;
#write <me.gg2tT.txt> "%e",Result

ExtraSymbols,array,w;
Format O3;
*Print;
.sort

Format DOUBLEFORTRAN;
#optimize Result
#write <me.gg2tT.f> "      FUNCTION me_gg2tT(S, T, U, T14, T24, S34, MT, GS, NF)"
#write <me.gg2tT.f> "      REAL*8 S, T, U, T14, T24, S34, MT, GS, NF"
#write <me.gg2tT.f> "      REAL*8 me_gg2tT"
#write <me.gg2tT.f> "      REAL*8 w(`optimmaxvar_')"
#write <me.gg2tT.f> "%O"
#write <me.gg2tT.f> "      me_gg2tT = %e",Result(me_gg2tT)
#write <me.gg2tT.f> "      RETURN"
#write <me.gg2tT.f> "      END"
.sort

.end
